.nolist	; prevents listing of includes
include \masm32\include\masm32rt.inc
include \masm32\macros\macros.asm ; for getkey
.list

; OPT_RUN	%oBody%.exe
; OPT_ARG1	"Hi jj2007, what a nice tool!"
; OPT_ARG2	"This demo has a title:"
; OPT_WAIT	0 ; 1 if you want to pause before exiting (but here we used getkey)
; OPT_LINK	; blank for defaults
; OPT_ASM	; blank for defaults
; OPT_RES	; e.g. rsrc.obj - leave blank if you don't use them
; OPT_CLEANLST 1 ;lst file is not needed, right?
; OPT_LOG	; demo_log.txt ; remove ";" before demo_log.txt to log the options


; OPT_SUSY CONSOLE ; inserted 07.12.2007, 11:07:26
; OPT_WAIT 1 ; press any key

.data?
hDll	dd ?
StdOut_c	dd ?
CLS_c	dd ?
TM_c	dd ?
ComLine	dd ?
CL_Buffer	BYTE 128 DUP(?)

.data
ExpNF	db "DLL entry not found:",0

dll_notf	db "DLL not found:",13,10	; no zero byte here...
dll_name	db "A simple dll.dll",0

message	db 'Hello world!',13,10
	db 'This is a simple console application'
	db ' - drag a file over the exe to see more',13,10,0

TM_title	db 'This is also a Windows GUI application:',0

.code

start:

invoke LoadLibrary, addr dll_name
mov hDll, eax
.if eax==0	; dll not found
  invoke MessageBox,0,addr dll_notf,chr$("DEMO"),MB_OK
  ret
.endif

invoke GetCL, 1, ADDR CL_Buffer
mov ComLine,eax

invoke GetProcAddress, hDll, chr$("StdOut")
mov	StdOut_c, eax
.if eax==0	; entry not found
  invoke MessageBox,0,chr$("StdOut not found"),chr$("DEMO"),MB_OK
  ret
.endif

invoke GetProcAddress, hDll, chr$("ClearScreen")
	mov CLS_c, eax
	.if eax==0	; entry not found
	  invoke MessageBox,0,chr$("ClearScreen not found"),chr$("DEMO"),MB_OK
	  ret
	.endif

invoke GetProcAddress, hDll, chr$("TellMe")	; test - this is actually MsgBox
	mov TM_c, eax
	.if eax==0	; entry not found
	  invoke MessageBox,0,chr$("TellMe not found"),addr ExpNF,MB_OK
	  ret
	.endif

;	invoke	ClearScreen
; 	call CLS_c
;	invoke	StdOut,ADDR message                                               
	push offset message
	call StdOut_c

	.if ComLine==1	; optional test:
		push MB_OK	; TellMe is MessageBox in disguise
		push offset TM_title
		push offset CL_Buffer ; Commandline arg 1
		push NULL
		call TM_c
	.else
		call ret_key
	.endif
	invoke FreeLibrary, hDll
	invoke ExitProcess,0
END start




